WndHello proc uses esi edi ebx, hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
					LOCAL	ps:PAINTSTRUCT
					LOCAL rect:RECT
					LOCAL hdc:DWORD
					LOCAL  hMenu:DWORD
					LOCAL  pHelloData:DWORD 

	.IF	uMsg == WM_CREATE		
		;Allocate memory for window private data
		invoke  GetProcessHeap
		invoke  HeapAlloc, eax, HEAP_ZERO_MEMORY, sizeof HELLODATA
		mov	ebx, eax
		mov	HELLODATA.iColour[ebx], IDM_COLOR_BLACK
		mov	HELLODATA.clrText[ebx],0	; RGB 0,0,0
		;mmorise le pointeur pour la feuille
		invoke SetProp,hWnd,addr prop_pointeur,ebx		
		return  0
	.ELSEIF uMsg == WM_COMMAND
		LOWORD	wParam
		.IF	eax==IDM_COLOR_BLACK || eax==IDM_COLOR_RED  || \
			eax==IDM_COLOR_GREEN || eax==IDM_COLOR_BLUE || eax==IDM_COLOR_WHITE
			;Change the text colour
			;----------------------
			invoke GetProp,hWnd,addr prop_pointeur			
			mov	pHelloData, eax
			mov	ebx,eax
			invoke  GetMenu, Frame.Hwnd
			mov	hMenu, eax
			invoke	CheckMenuItem, hMenu, HELLODATA.iColour[ebx], MF_UNCHECKED
			PuPo	HELLODATA.iColour[ebx], wParam
			invoke	CheckMenuItem, hMenu, HELLODATA.iColour[ebx], MF_CHECKED
			mov	esi, wParam
			sub	esi, IDM_COLOR_BLACK
			shl	esi,2				; Make dword index
			mov	eax, clrTextArray[esi]
			mov	HELLODATA.clrText[ebx], eax
			invoke	InvalidateRect, hWnd, 0,0
		.ENDIF	
		return 0	
	.ELSEIF uMsg == WM_PAINT

		invoke	BeginPaint, hWnd, ADDR ps
		mov	hdc, eax
		invoke GetProp,hWnd,addr prop_pointeur					
		mov	pHelloData,eax
		mov	ebx,eax
		invoke	SetTextColor, hdc, HELLODATA.clrText[ebx]	 
		invoke  GetClientRect, hWnd, ADDR rect

		invoke	DrawText, hdc, ADDR szHelloW, -1, ADDR rect, \	; Write "Hello World"
			DT_SINGLELINE or DT_CENTER or DT_VCENTER	; to child window

		invoke	EndPaint, hWnd, ADDR ps
		return 0

	.ELSEIF	uMsg == WM_MDIACTIVATE
		
;		Set the Hello menu if gaining focus
;		-----------------------------------
		mov	eax, lParam
		.IF	eax==hWnd
			invoke SendMessage, Frame.Hclientcreate, WM_MDISETMENU, \
					hello.Hmenu, hello.Hsubmenu
		.ENDIF		
;		Check/Uncheck menu item
;		-----------------------
		invoke GetProp,hWnd,addr prop_pointeur		
		mov	pHelloData,eax
		mov	ebx,eax
		mov	eax, hWnd
		.IF	eax==lParam
			mov	eax, MF_CHECKED
		.ELSE
			mov eax, MF_UNCHECKED
		.ENDIF
		invoke	CheckMenuItem,hello.Hmenu, \ ;	Returns previous state; 8 if 
			HELLODATA.iColour[ebx], eax  ;  previously checked, 0 if unchecked					
;		Set the Init menu if losing focus
;		---------------------------------		
		mov	eax, hWnd
		.IF	eax != lParam
			invoke SendMessage, Frame.Hclientcreate, WM_MDISETMENU, \
					Frame.Hmenu,Frame.Hsubmenu	 		
		.ENDIF
		invoke DrawMenuBar, Frame.Hwnd		; Redraw the menu bar
		return 0
	.ELSEIF	uMsg == WM_QUERYENDSESSION || uMsg == WM_CLOSE
		invoke	MessageBox, hWnd, ADDR szOK2Close, ADDR szHello, \
			MB_ICONQUESTION or MB_OKCANCEL
		.IF	eax != IDOK
			return 0 
		.ENDIF	
	.ELSEIF	uMsg==WM_DESTROY	
		invoke GetProp,hWnd,addr prop_pointeur			
		mov	pHelloData, eax			
		invoke	GetProcessHeap
		invoke	HeapFree, eax, 0, pHelloData 
		invoke 	RemoveProp,hWnd,addr prop_pointeur		
		return 0
	.ENDIF
;	Pass unprocessed messages
	invoke  DefMDIChildProc, hWnd, uMsg, wParam, lParam
	return	eax
		
WndHello	endp

